block: add bdrv_find_backing_image
[qemu.git] / Makefile
1 # Makefile for QEMU.
2
3 # Always point to the root of the build tree (needs GNU make).
4 BUILD_DIR=$(CURDIR)
5
6 GENERATED_HEADERS = config-host.h trace.h qemu-options.def
7 ifeq ($(TRACE_BACKEND),dtrace)
8 GENERATED_HEADERS += trace-dtrace.h
9 endif
10 GENERATED_HEADERS += qmp-commands.h qapi-types.h qapi-visit.h
11 GENERATED_SOURCES += qmp-marshal.c qapi-types.c qapi-visit.c
12
13 ifneq ($(wildcard config-host.mak),)
14 # Put the all: rule here so that config-host.mak can contain dependencies.
15 all: build-all
16 include config-host.mak
17 include $(SRC_PATH)/rules.mak
18 config-host.mak: $(SRC_PATH)/configure
19 @echo $@ is out-of-date, running configure
20 @sed -n "/.*Configured with/s/[^:]*: //p" $@ | sh
21 else
22 config-host.mak:
23 @echo "Please call configure before running make!"
24 @exit 1
25 endif
26
27 # Don't try to regenerate Makefile or configure
28 # We don't generate any of them
29 Makefile: ;
30 configure: ;
31
32 .PHONY: all clean cscope distclean dvi html info install install-doc \
33 pdf recurse-all speed tar tarbin test build-all
34
35 $(call set-vpath, $(SRC_PATH):$(SRC_PATH)/hw)
36
37 LIBS+=-lz $(LIBS_TOOLS)
38
39 ifdef BUILD_DOCS
40 DOCS=qemu-doc.html qemu-tech.html qemu.1 qemu-img.1 qemu-nbd.8 QMP/qmp-commands.txt
41 DOCS+=fsdev/virtfs-proxy-helper.1
42 else
43 DOCS=
44 endif
45
46 SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory) BUILD_DIR=$(BUILD_DIR)
47 SUBDIR_DEVICES_MAK=$(patsubst %, %/config-devices.mak, $(TARGET_DIRS))
48 SUBDIR_DEVICES_MAK_DEP=$(patsubst %, %/config-devices.mak.d, $(TARGET_DIRS))
49
50 config-all-devices.mak: $(SUBDIR_DEVICES_MAK)
51 $(call quiet-command,cat $(SUBDIR_DEVICES_MAK) | grep =y | sort -u > $@," GEN $@")
52
53 -include $(SUBDIR_DEVICES_MAK_DEP)
54
55 %/config-devices.mak: default-configs/%.mak
56 $(call quiet-command,$(SHELL) $(SRC_PATH)/scripts/make_device_config.sh $@ $<, " GEN $@")
57 @if test -f $@; then \
58 if cmp -s $@.old $@; then \
59 mv $@.tmp $@; \
60 cp -p $@ $@.old; \
61 else \
62 if test -f $@.old; then \
63 echo "WARNING: $@ (user modified) out of date.";\
64 else \
65 echo "WARNING: $@ out of date.";\
66 fi; \
67 echo "Run \"make defconfig\" to regenerate."; \
68 rm $@.tmp; \
69 fi; \
70 else \
71 mv $@.tmp $@; \
72 cp -p $@ $@.old; \
73 fi
74
75 defconfig:
76 rm -f config-all-devices.mak $(SUBDIR_DEVICES_MAK)
77
78 -include config-all-devices.mak
79
80 build-all: $(DOCS) $(TOOLS) recurse-all
81
82 config-host.h: config-host.h-timestamp
83 config-host.h-timestamp: config-host.mak
84 qemu-options.def: $(SRC_PATH)/qemu-options.hx
85 $(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@," GEN $@")
86
87 SUBDIR_RULES=$(patsubst %,subdir-%, $(TARGET_DIRS))
88
89 subdir-%: $(GENERATED_HEADERS)
90 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $* V="$(V)" TARGET_DIR="$*/" all,)
91
92 ifneq ($(wildcard config-host.mak),)
93 include $(SRC_PATH)/Makefile.objs
94 endif
95
96 $(common-obj-y): $(GENERATED_HEADERS)
97 subdir-libcacard: $(oslib-obj-y) $(trace-obj-y) qemu-timer-common.o
98
99 $(filter %-softmmu,$(SUBDIR_RULES)): $(trace-obj-y) $(common-obj-y) subdir-libdis
100
101 $(filter %-user,$(SUBDIR_RULES)): $(GENERATED_HEADERS) $(trace-obj-y) subdir-libdis-user subdir-libuser
102
103 ROMSUBDIR_RULES=$(patsubst %,romsubdir-%, $(ROMS))
104 romsubdir-%:
105 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C pc-bios/$* V="$(V)" TARGET_DIR="$*/",)
106
107 ALL_SUBDIRS=$(TARGET_DIRS) $(patsubst %,pc-bios/%, $(ROMS))
108
109 recurse-all: $(SUBDIR_RULES) $(ROMSUBDIR_RULES)
110
111 audio/audio.o audio/fmodaudio.o: QEMU_CFLAGS += $(FMOD_CFLAGS)
112
113 QEMU_CFLAGS+=$(CURL_CFLAGS)
114
115 QEMU_CFLAGS+=$(GLIB_CFLAGS)
116
117 ui/cocoa.o: ui/cocoa.m
118
119 ui/sdl.o audio/sdlaudio.o ui/sdl_zoom.o baum.o: QEMU_CFLAGS += $(SDL_CFLAGS)
120
121 ui/vnc.o: QEMU_CFLAGS += $(VNC_TLS_CFLAGS)
122
123 bt-host.o: QEMU_CFLAGS += $(BLUEZ_CFLAGS)
124
125 version.o: $(SRC_PATH)/version.rc config-host.h
126 $(call quiet-command,$(WINDRES) -I. -o $@ $<," RC $(TARGET_DIR)$@")
127
128 version-obj-$(CONFIG_WIN32) += version.o
129 ######################################################################
130 # Support building shared library libcacard
131
132 .PHONY: libcacard.la install-libcacard
133 ifeq ($(LIBTOOL),)
134 libcacard.la:
135 @echo "libtool is missing, please install and rerun configure"; exit 1
136
137 install-libcacard:
138 @echo "libtool is missing, please install and rerun configure"; exit 1
139 else
140 libcacard.la: $(GENERATED_HEADERS) $(oslib-obj-y) qemu-timer-common.o $(addsuffix .lo, $(basename $(trace-obj-y)))
141 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C libcacard V="$(V)" TARGET_DIR="$*/" libcacard.la,)
142
143 install-libcacard: libcacard.la
144 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C libcacard V="$(V)" TARGET_DIR="$*/" install-libcacard,)
145 endif
146 ######################################################################
147
148 qemu-img.o: qemu-img-cmds.h
149 qemu-img.o qemu-tool.o qemu-nbd.o qemu-io.o cmd.o qemu-ga.o: $(GENERATED_HEADERS)
150
151 tools-obj-y = $(oslib-obj-y) $(trace-obj-y) qemu-tool.o qemu-timer.o \
152 qemu-timer-common.o main-loop.o notify.o iohandler.o cutils.o async.o
153 tools-obj-$(CONFIG_POSIX) += compatfd.o
154
155 qemu-img$(EXESUF): qemu-img.o $(tools-obj-y) $(block-obj-y)
156 qemu-nbd$(EXESUF): qemu-nbd.o $(tools-obj-y) $(block-obj-y)
157 qemu-io$(EXESUF): qemu-io.o cmd.o $(tools-obj-y) $(block-obj-y)
158
159 fsdev/virtfs-proxy-helper$(EXESUF): fsdev/virtfs-proxy-helper.o fsdev/virtio-9p-marshal.o oslib-posix.o $(trace-obj-y)
160 fsdev/virtfs-proxy-helper$(EXESUF): LIBS += -lcap
161
162 qemu-img-cmds.h: $(SRC_PATH)/qemu-img-cmds.hx
163 $(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@," GEN $@")
164
165 $(qapi-obj-y): $(GENERATED_HEADERS)
166 qapi-dir := $(BUILD_DIR)/qapi-generated
167 qemu-ga$(EXESUF): LIBS = $(LIBS_QGA)
168
169 gen-out-type = $(subst .,-,$(suffix $@))
170
171 ifneq ($(wildcard config-host.mak),)
172 include $(SRC_PATH)/tests/Makefile
173 endif
174
175 $(qapi-dir)/qga-qapi-types.c $(qapi-dir)/qga-qapi-types.h :\
176 $(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-types.py
177 $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o "$(qapi-dir)" -p "qga-" < $<, " GEN $@")
178 $(qapi-dir)/qga-qapi-visit.c $(qapi-dir)/qga-qapi-visit.h :\
179 $(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-visit.py
180 $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o "$(qapi-dir)" -p "qga-" < $<, " GEN $@")
181 $(qapi-dir)/qga-qmp-commands.h $(qapi-dir)/qga-qmp-marshal.c :\
182 $(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-commands.py
183 $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -o "$(qapi-dir)" -p "qga-" < $<, " GEN $@")
184
185 qapi-types.c qapi-types.h :\
186 $(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-types.py
187 $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o "." < $<, " GEN $@")
188 qapi-visit.c qapi-visit.h :\
189 $(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-visit.py
190 $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o "." < $<, " GEN $@")
191 qmp-commands.h qmp-marshal.c :\
192 $(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-commands.py
193 $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -m -o "." < $<, " GEN $@")
194
195 QGALIB_OBJ=$(addprefix $(qapi-dir)/, qga-qapi-types.o qga-qapi-visit.o qga-qmp-marshal.o)
196 QGALIB_GEN=$(addprefix $(qapi-dir)/, qga-qapi-types.h qga-qapi-visit.h qga-qmp-commands.h)
197 $(QGALIB_OBJ): $(QGALIB_GEN) $(GENERATED_HEADERS)
198 $(qga-obj-y) qemu-ga.o: $(QGALIB_GEN) $(GENERATED_HEADERS)
199
200 qemu-ga$(EXESUF): qemu-ga.o $(qga-obj-y) $(qapi-obj-y) $(tools-obj-y) $(qobject-obj-y) $(version-obj-y) $(QGALIB_OBJ)
201
202 QEMULIBS=libhw32 libhw64 libuser libdis libdis-user
203
204 clean:
205 # avoid old build problems by removing potentially incorrect old files
206 rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
207 rm -f qemu-options.def
208 rm -f *.o *.d *.a *.lo $(TOOLS) qemu-ga TAGS cscope.* *.pod *~ */*~
209 rm -Rf .libs
210 rm -f slirp/*.o slirp/*.d audio/*.o audio/*.d block/*.o block/*.d net/*.o net/*.d fsdev/*.o fsdev/*.d ui/*.o ui/*.d qapi/*.o qapi/*.d qga/*.o qga/*.d
211 rm -f qemu-img-cmds.h
212 rm -f trace/*.o trace/*.d
213 rm -f trace.c trace.h trace.c-timestamp trace.h-timestamp
214 rm -f trace-dtrace.dtrace trace-dtrace.dtrace-timestamp
215 rm -f trace-dtrace.h trace-dtrace.h-timestamp
216 rm -f $(GENERATED_HEADERS)
217 rm -f $(GENERATED_SOURCES)
218 rm -rf $(qapi-dir)
219 $(MAKE) -C tests/tcg clean
220 for d in $(ALL_SUBDIRS) $(QEMULIBS) libcacard; do \
221 if test -d $$d; then $(MAKE) -C $$d $@ || exit 1; fi; \
222 rm -f $$d/qemu-options.def; \
223 done
224
225 distclean: clean
226 rm -f config-host.mak config-host.h* config-host.ld $(DOCS) qemu-options.texi qemu-img-cmds.texi qemu-monitor.texi
227 rm -f config-all-devices.mak
228 rm -f roms/seabios/config.mak roms/vgabios/config.mak
229 rm -f qemu-doc.info qemu-doc.aux qemu-doc.cp qemu-doc.cps qemu-doc.dvi
230 rm -f qemu-doc.fn qemu-doc.fns qemu-doc.info qemu-doc.ky qemu-doc.kys
231 rm -f qemu-doc.log qemu-doc.pdf qemu-doc.pg qemu-doc.toc qemu-doc.tp
232 rm -f qemu-doc.vr
233 rm -f config.log
234 rm -f qemu-tech.info qemu-tech.aux qemu-tech.cp qemu-tech.dvi qemu-tech.fn qemu-tech.info qemu-tech.ky qemu-tech.log qemu-tech.pdf qemu-tech.pg qemu-tech.toc qemu-tech.tp qemu-tech.vr
235 for d in $(TARGET_DIRS) $(QEMULIBS); do \
236 rm -rf $$d || exit 1 ; \
237 done
238
239 KEYMAPS=da en-gb et fr fr-ch is lt modifiers no pt-br sv \
240 ar de en-us fi fr-be hr it lv nl pl ru th \
241 common de-ch es fo fr-ca hu ja mk nl-be pt sl tr
242
243 ifdef INSTALL_BLOBS
244 BLOBS=bios.bin sgabios.bin vgabios.bin vgabios-cirrus.bin \
245 vgabios-stdvga.bin vgabios-vmware.bin vgabios-qxl.bin \
246 ppc_rom.bin openbios-sparc32 openbios-sparc64 openbios-ppc \
247 pxe-e1000.rom pxe-eepro100.rom pxe-ne2k_pci.rom \
248 pxe-pcnet.rom pxe-rtl8139.rom pxe-virtio.rom \
249 bamboo.dtb petalogix-s3adsp1800.dtb petalogix-ml605.dtb \
250 mpc8544ds.dtb \
251 multiboot.bin linuxboot.bin \
252 s390-zipl.rom \
253 spapr-rtas.bin slof.bin \
254 palcode-clipper
255 else
256 BLOBS=
257 endif
258
259 install-doc: $(DOCS)
260 $(INSTALL_DIR) "$(DESTDIR)$(docdir)"
261 $(INSTALL_DATA) qemu-doc.html qemu-tech.html "$(DESTDIR)$(docdir)"
262 ifdef CONFIG_POSIX
263 $(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
264 $(INSTALL_DATA) qemu.1 qemu-img.1 "$(DESTDIR)$(mandir)/man1"
265 $(INSTALL_DIR) "$(DESTDIR)$(mandir)/man8"
266 $(INSTALL_DATA) qemu-nbd.8 "$(DESTDIR)$(mandir)/man8"
267 endif
268 ifdef CONFIG_VIRTFS
269 $(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
270 $(INSTALL_DATA) fsdev/virtfs-proxy-helper.1 "$(DESTDIR)$(mandir)/man1"
271 endif
272 install-sysconfig:
273 $(INSTALL_DIR) "$(DESTDIR)$(sysconfdir)/qemu"
274 $(INSTALL_DATA) $(SRC_PATH)/sysconfigs/target/target-x86_64.conf "$(DESTDIR)$(sysconfdir)/qemu"
275
276 install: all $(if $(BUILD_DOCS),install-doc) install-sysconfig
277 $(INSTALL_DIR) "$(DESTDIR)$(bindir)"
278 ifneq ($(TOOLS),)
279 $(INSTALL_PROG) $(STRIP_OPT) $(TOOLS) "$(DESTDIR)$(bindir)"
280 endif
281 ifneq ($(BLOBS),)
282 $(INSTALL_DIR) "$(DESTDIR)$(datadir)"
283 set -e; for x in $(BLOBS); do \
284 $(INSTALL_DATA) $(SRC_PATH)/pc-bios/$$x "$(DESTDIR)$(datadir)"; \
285 done
286 endif
287 $(INSTALL_DIR) "$(DESTDIR)$(datadir)/keymaps"
288 set -e; for x in $(KEYMAPS); do \
289 $(INSTALL_DATA) $(SRC_PATH)/pc-bios/keymaps/$$x "$(DESTDIR)$(datadir)/keymaps"; \
290 done
291 for d in $(TARGET_DIRS); do \
292 $(MAKE) -C $$d $@ || exit 1 ; \
293 done
294
295 # various test targets
296 test speed: all
297 $(MAKE) -C tests/tcg $@
298
299 .PHONY: TAGS
300 TAGS:
301 find "$(SRC_PATH)" -name '*.[hc]' -print0 | xargs -0 etags
302
303 cscope:
304 rm -f ./cscope.*
305 find "$(SRC_PATH)" -name "*.[chsS]" -print | sed 's,^\./,,' > ./cscope.files
306 cscope -b
307
308 # documentation
309 MAKEINFO=makeinfo
310 MAKEINFOFLAGS=--no-headers --no-split --number-sections
311 TEXIFLAG=$(if $(V),,--quiet)
312 %.dvi: %.texi
313 $(call quiet-command,texi2dvi $(TEXIFLAG) -I . $<," GEN $@")
314
315 %.html: %.texi
316 $(call quiet-command,$(MAKEINFO) $(MAKEINFOFLAGS) --html $< -o $@, \
317 " GEN $@")
318
319 %.info: %.texi
320 $(call quiet-command,$(MAKEINFO) $< -o $@," GEN $@")
321
322 %.pdf: %.texi
323 $(call quiet-command,texi2pdf $(TEXIFLAG) -I . $<," GEN $@")
324
325 qemu-options.texi: $(SRC_PATH)/qemu-options.hx
326 $(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -t < $< > $@," GEN $@")
327
328 qemu-monitor.texi: $(SRC_PATH)/hmp-commands.hx
329 $(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -t < $< > $@," GEN $@")
330
331 QMP/qmp-commands.txt: $(SRC_PATH)/qmp-commands.hx
332 $(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -q < $< > $@," GEN $@")
333
334 qemu-img-cmds.texi: $(SRC_PATH)/qemu-img-cmds.hx
335 $(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -t < $< > $@," GEN $@")
336
337 qemu.1: qemu-doc.texi qemu-options.texi qemu-monitor.texi
338 $(call quiet-command, \
339 perl -Ww -- $(SRC_PATH)/scripts/texi2pod.pl $< qemu.pod && \
340 pod2man --section=1 --center=" " --release=" " qemu.pod > $@, \
341 " GEN $@")
342
343 qemu-img.1: qemu-img.texi qemu-img-cmds.texi
344 $(call quiet-command, \
345 perl -Ww -- $(SRC_PATH)/scripts/texi2pod.pl $< qemu-img.pod && \
346 pod2man --section=1 --center=" " --release=" " qemu-img.pod > $@, \
347 " GEN $@")
348
349 fsdev/virtfs-proxy-helper.1: fsdev/virtfs-proxy-helper.texi
350 $(call quiet-command, \
351 perl -Ww -- $(SRC_PATH)/scripts/texi2pod.pl $< fsdev/virtfs-proxy-helper.pod && \
352 pod2man --section=1 --center=" " --release=" " fsdev/virtfs-proxy-helper.pod > $@, \
353 " GEN $@")
354
355 qemu-nbd.8: qemu-nbd.texi
356 $(call quiet-command, \
357 perl -Ww -- $(SRC_PATH)/scripts/texi2pod.pl $< qemu-nbd.pod && \
358 pod2man --section=8 --center=" " --release=" " qemu-nbd.pod > $@, \
359 " GEN $@")
360
361 dvi: qemu-doc.dvi qemu-tech.dvi
362 html: qemu-doc.html qemu-tech.html
363 info: qemu-doc.info qemu-tech.info
364 pdf: qemu-doc.pdf qemu-tech.pdf
365
366 qemu-doc.dvi qemu-doc.html qemu-doc.info qemu-doc.pdf: \
367 qemu-img.texi qemu-nbd.texi qemu-options.texi \
368 qemu-monitor.texi qemu-img-cmds.texi
369
370 VERSION ?= $(shell cat VERSION)
371 FILE = qemu-$(VERSION)
372
373 # tar release (use 'make -k tar' on a checkouted tree)
374 tar:
375 rm -rf /tmp/$(FILE)
376 cp -r . /tmp/$(FILE)
377 cd /tmp && tar zcvf ~/$(FILE).tar.gz $(FILE) --exclude CVS --exclude .git --exclude .svn
378 rm -rf /tmp/$(FILE)
379
380 # Include automatically generated dependency files
381 -include $(wildcard *.d audio/*.d slirp/*.d block/*.d net/*.d ui/*.d qapi/*.d qga/*.d)